<!-- Linea 14 -->
<div>
  <ul class="alert alert-danger" *ngIf="errores.length > 0">
    <li *ngFor="let err of errores">
        {{ err }}
    </li>
  </ul>
</div>

<!-- Linea 1 -->
<div class="card bg-dark text-white">
   <div class="card-header">{{ titulo }}</div>
   <div class="card-body">
       <!-- Linea 6 --> <!-- Linea 12 -->
       <!-- <form (ngSubmit)="create()"> -->
       <form #clienteForm="ngForm">
           <!-- Linea 2A -->
           <div class="form-group row mb-2">
              <label for="nombre" class="col-form-label col-sm-2">Nombre</label>
              <div class="col-sm-6">
                 <!-- Linea 2B --> <!-- Linea 8 --> <!-- Linea 9 -->
                 <!-- <input type="text" class="form-control" name="nombre" [(ngModel)]="cliente.nombre" required minlength="4" #nombre="ngModel"> -->
                 <!-- Linea 15 -->
                 <input type="text" class="form-control" name="nombre" [(ngModel)]="cliente.nombre" #nombre="ngModel">
                 <!-- Linea 11 -->
                 <div class="alert alert-danger" *ngIf="nombre.invalid && (nombre.dirty || nombre.touched)">
                   <div *ngIf="nombre.errors?.required">
                      Nombre es requerido
                   </div>
                   <div *ngIf="nombre.errors?.minlength">
                      Nombre debe tener al menos 4 caracteres
                   </div>
                 </div>
              </div>
           </div>

           <!-- Linea 3A -->
           <div class="form-group row mb-2">
              <label for="apellido" class="col-form-label col-sm-2">Apellido</label>
              <div class="col-sm-6">
                 <!-- Linea 3B --> <!-- Linea 8 --> <!-- Linea 9 -->
                 <!-- <input type="text" class="form-control" name="apellido" [(ngModel)]="cliente.apellido" required minlength="4" #apellido="ngModel"> -->
                 <!-- Linea 15 -->
                 <input type="text" class="form-control" name="apellido" [(ngModel)]="cliente.apellido" #apellido="ngModel">
                 <!-- Linea 11 -->
                 <div class="alert alert-danger" *ngIf="apellido.invalid && (apellido.dirty || apellido.touched)">
                   <div *ngIf="apellido.errors?.required">
                      Apellido es requerido
                   </div>
                   <div *ngIf="apellido.errors?.minlength">
                      Apellido debe tener al menos 4 caracteres
                   </div>
                 </div>
              </div>
           </div>

           <!-- Linea 4A -->
           <div class="form-group row mb-2">
              <label for="email" class="col-form-label col-sm-2">Email</label>
              <div class="col-sm-6">
                 <!-- Linea 4B --> <!-- Linea 8 --> <!-- Linea 10 -->
                 <!-- <input type="text" class="form-control" name="email" [(ngModel)]="cliente.email" required email #email="ngModel"> -->
                 <!-- Linea 15 -->
                 <input type="text" class="form-control" name="email" [(ngModel)]="cliente.email" #email="ngModel">
                 <!-- Linea 11 -->
                 <div class="alert alert-danger" *ngIf="email.invalid && (email.dirty || email.touched)">
                   <div *ngIf="email.errors?.required">
                      Email es requerido
                   </div>
                   <div *ngIf="email.errors?.email">
                      El email debe tener un formato valido
                   </div>
                 </div>
              </div>
           </div>

           <!-- Linea 16 -->
           <div class="form-group row mb-2">
              <label for="createAt" class="col-form-label col-sm-2">Fecha</label>
              <div class="col-sm-6">
                 <input matInput [matDatepicker]="miDatepicker" class="form-control" [(ngModel)]="cliente.createAt" name="createAt" style="display:inline; width:300px;">
                 <mat-datepicker-toggle matSuffix [for]="miDatepicker"></mat-datepicker-toggle>
                 <mat-datepicker #miDatepicker></mat-datepicker>
              </div>
           </div>

           <!-- Linea 17 -->
           <div class="form-group row mb-2">
              <label for="region" class="col-form-label col-sm-2">Regiones</label>
              <div class="col-sm-6">
                 <!-- Linea 18 -->
                 <select [compareWith]="compararRegion" class="form-control" [(ngModel)]="cliente.region" name="region" style="width:500px;">
                   <option [ngValue]="undefined">--- Seleccionar una region ---</option>
                   <option *ngFor="let region of regiones" [ngValue]="region">{{region.nombre}}</option>
                 </select>
              </div>
           </div>

           <!-- Linea 5A -->
           <div class="form-group row">
              <div class="col-sm-6">
                 <!-- <button class="btn btn-primary" role="button"> Crear Cliente </button> -->
                 <!-- Linea 7 --> <!-- Linea 13 -->
                 <button class="btn btn-primary" role="button" (click)='create()' *ngIf="!cliente.id else elseBlock" [disabled]="!clienteForm.form.valid"> Crear </button>
                 <ng-template #elseBlock>
                     <!-- Linea 13 -->
                     <button class="btn btn-primary" role="button" (click)='update()' [disabled]="!clienteForm.form.valid"> Editar </button>
                 </ng-template>
              </div>
           </div>
       </form>
   </div>
</div>

<!-- Tarea  66 -->
  <!-- Linea 1: Crear el formulario -->
  <!-- Linea 2A: Crear el campo para nombre -->
  <!-- Linea 2B: Mapear el campo nombre con el atributo cliente.nombre con ngModel -->
  <!-- Linea 3A: Crear el campo para apellido -->
  <!-- Linea 3B: Mapear el campo apellido con el atributo cliente.apellido con ngModel -->
  <!-- Linea 4A: Crear el campo para email -->
  <!-- Linea 4B: Mapear el campo email con el atributo cliente.email con ngModel -->
  <!-- Linea 5A: Crear el boton -->
  <!-- Linea  6: Crear la directa ngSubmit en el formulario hacia el metodo create() -->

<!-- Tarea 79 -->
  <!-- Linea  7: Incluir el metodo click que invoca al metodo create y una condicion ngIf
       que invoca el boton Crear Cliente cuando no hay id y la template cuando hay id -->

<!-- Tarea 88 -->
  <!-- Linea  8: Agregar el validador require en los inputs -->
  <!-- Linea  9: Agregar el validador min-minlength en los inputs -->
  <!-- Linea 10: Agregar el validador email en el input del correo -->
  <!-- Linea 11: Crear mensajes de error de los validadores -->
  <!-- Linea 12: Desabilitar el boton de crear al estar sin validar los campos con #clienteForm="ngForm" -->
  <!-- Linea 13: Desabilitar el boton de crear al estar sin validar los campos con [disabled]="!clienteForm.form.valid" -->

<!-- Tarea 93 -->
  <!-- Linea 14: Crear ul-li que mostrara la lista de errores que viene del back end -->
  <!-- Linea 15: Quitar validadores que habiamos puesto en los controles -->

<!-- Tarea 121 -->
  <!-- Linea 16: Creacion del control de fecha en la plantilla del formulario -->

<!-- Tarea 170 -->
  <!-- Linea 17: Implementacion del campo select para desplegar las regiones -->
  <!-- Linea 18: Implementacion de la directiva [compareWith]="compararRegion" que invocara el metodo compararRegion
       el cual seleccionara la region que tenemos en el [ngModel] de todas las regiones del ngFor -->
